From 7a833e26d4ccae3a3876ae65da0c4887435db938 Mon Sep 17 00:00:00 2001
From: David Malcolm <dmalcolm@redhat.com>
Date: Fri, 19 Sep 2025 13:23:07 -0400
Subject: [PATCH] {needs finishing, ChangeLog, blurb}: analyzer: reimplement
 supergraph to eliminate function_point and stmt_finder

---
 gcc/Makefile.in                               |    4 +
 gcc/analyzer/analyzer-logging.h               |   41 +
 gcc/analyzer/analyzer.cc                      |   10 +
 gcc/analyzer/analyzer.opt                     |    8 +-
 gcc/analyzer/bounds-checking.cc               |    2 +-
 gcc/analyzer/call-details.h                   |    2 +
 gcc/analyzer/call-info.cc                     |   17 +-
 gcc/analyzer/call-info.h                      |    3 +-
 gcc/analyzer/call-string.cc                   |   94 +-
 gcc/analyzer/call-string.h                    |   63 +-
 gcc/analyzer/call-summary.cc                  |    6 +-
 gcc/analyzer/checker-event.cc                 |  285 +-
 gcc/analyzer/checker-event.h                  |  107 +-
 gcc/analyzer/common.h                         |   36 +-
 gcc/analyzer/constraint-manager.cc            |   47 -
 gcc/analyzer/constraint-manager.h             |   19 +-
 gcc/analyzer/diagnostic-manager.cc            |  813 +----
 gcc/analyzer/diagnostic-manager.h             |  101 +-
 gcc/analyzer/engine.cc                        | 3250 +++++------------
 gcc/analyzer/event-loc-info.h                 |    3 +
 gcc/analyzer/exploded-graph.h                 |  226 +-
 gcc/analyzer/feasible-graph.cc                |   32 +-
 gcc/analyzer/impl-sm-context.h                |  284 ++
 gcc/analyzer/infinite-loop.cc                 |  154 +-
 gcc/analyzer/infinite-recursion.cc            |   39 +-
 gcc/analyzer/kf-lang-cp.cc                    |   57 +-
 gcc/analyzer/ops.cc                           | 2428 ++++++++++++
 gcc/analyzer/ops.h                            |  979 +++++
 gcc/analyzer/pending-diagnostic.cc            |   15 +-
 gcc/analyzer/pending-diagnostic.h             |   15 +-
 gcc/analyzer/program-point.cc                 |  606 +--
 gcc/analyzer/program-point.h                  |  199 +-
 gcc/analyzer/program-state.cc                 |  166 +-
 gcc/analyzer/program-state.h                  |   16 -
 gcc/analyzer/region-model-manager.cc          |   46 +-
 gcc/analyzer/region-model-manager.h           |    2 +-
 gcc/analyzer/region-model.cc                  |  701 +---
 gcc/analyzer/region-model.h                   |  123 +-
 gcc/analyzer/region.cc                        |    3 +
 gcc/analyzer/sm-fd.cc                         |  321 +-
 gcc/analyzer/sm-file.cc                       |   33 +-
 gcc/analyzer/sm-malloc.cc                     |  271 +-
 gcc/analyzer/sm-pattern-test.cc               |   11 +-
 gcc/analyzer/sm-sensitive.cc                  |   16 +-
 gcc/analyzer/sm-signal.cc                     |    8 +-
 gcc/analyzer/sm-taint.cc                      |   80 +-
 gcc/analyzer/sm.cc                            |   10 +-
 gcc/analyzer/sm.h                             |   62 +-
 gcc/analyzer/state-purge.cc                   |  820 ++---
 gcc/analyzer/state-purge.h                    |  126 +-
 gcc/analyzer/store.cc                         |   22 +-
 gcc/analyzer/supergraph-fixup-locations.cc    |  139 +
 gcc/analyzer/supergraph-manipulation.h        |   73 +
 gcc/analyzer/supergraph-simplify.cc           |  330 ++
 gcc/analyzer/supergraph-sorting.cc            |  281 ++
 gcc/analyzer/supergraph.cc                    | 1705 ++++-----
 gcc/analyzer/supergraph.h                     |  693 +---
 gcc/analyzer/svalue.cc                        |   31 +-
 gcc/analyzer/svalue.h                         |   22 +-
 gcc/analyzer/varargs.cc                       |   68 +-
 gcc/digraph.h                                 |   52 +-
 gcc/doc/analyzer.texi                         |  116 +-
 gcc/doc/invoke.texi                           |   39 +-
 gcc/gdbhooks.py                               |    2 +-
 gcc/system.h                                  |    3 +
 .../analyzer/allocation-size-multiline-1.c    |   10 +-
 .../c-c++-common/analyzer/bzip2-arg-parse-1.c |    5 +-
 .../analyzer/coreutils-cksum-pr108664.c       |    4 +-
 .../analyzer/coreutils-group_number.c         |   43 +
 .../c-c++-common/analyzer/data-model-20.c     |    4 +-
 .../deref-before-check-qemu-qtest_rsp_args.c  |   14 +-
 .../c-c++-common/analyzer/dot-output.c        |    8 +-
 .../analyzer/fd-symbolic-socket.c             |    9 +-
 .../c-c++-common/analyzer/fibonacci.c         |    2 +-
 .../analyzer/flex-with-call-summaries.c       |    2 +-
 .../analyzer/flex-without-call-summaries.c    |    6 +-
 .../analyzer/infinite-recursion-5.c           |    3 +
 .../analyzer/infinite-recursion-pr108524-2.c  |    2 +-
 .../c-c++-common/analyzer/invalid-shift-1.c   |    5 +-
 gcc/testsuite/c-c++-common/analyzer/loop-4.c  |    6 +-
 .../analyzer/loop-n-down-to-1-by-1.c          |    4 +-
 gcc/testsuite/c-c++-common/analyzer/loop.c    |    2 +-
 .../c-c++-common/analyzer/malloc-ipa-11.c     |    1 +
 .../analyzer/out-of-bounds-coreutils.c        |    2 +-
 gcc/testsuite/c-c++-common/analyzer/paths-4.c |   10 +-
 .../c-c++-common/analyzer/pr94362-1.c         |    3 -
 .../c-c++-common/analyzer/pr94851-2.c         |    2 +-
 .../c-c++-common/analyzer/pr96650-1-notrans.c |    1 +
 gcc/testsuite/c-c++-common/analyzer/pr98628.c |    2 +-
 .../c-c++-common/analyzer/pr99774-1.c         |    2 +-
 .../c-c++-common/analyzer/pragma-2.c          |    2 +-
 .../c-c++-common/analyzer/realloc-1.c         |    2 +-
 gcc/testsuite/c-c++-common/analyzer/sock-1.c  |    1 +
 .../c-c++-common/analyzer/sprintf-2.c         |    3 +-
 .../c-c++-common/analyzer/sprintf-concat.c    |    4 +-
 .../c-c++-common/analyzer/stdarg-sentinel-1.c |    2 +-
 .../c-c++-common/analyzer/strncpy-1.c         |    4 +-
 .../c-c++-common/analyzer/strstr-1.c          |    4 +-
 gcc/testsuite/g++.dg/analyzer/analyzer.exp    |    2 +-
 .../g++.dg/analyzer/exception-value-2.C       |    1 +
 ...er-show-events-in-system-headers-default.C |    2 -
 ...nalyzer-show-events-in-system-headers-no.C |    2 -
 .../fanalyzer-show-events-in-system-headers.C |    2 +-
 gcc/testsuite/g++.dg/analyzer/pr94028.C       |    4 +-
 gcc/testsuite/g++.dg/analyzer/pr96641.C       |    2 +-
 .../gcc.dg/analyzer/CWE-131-examples.c        |    2 +-
 gcc/testsuite/gcc.dg/analyzer/abs-1.c         |    2 +-
 .../gcc.dg/analyzer/analyzer-decls.h          |   60 +-
 gcc/testsuite/gcc.dg/analyzer/analyzer.exp    |    2 +-
 .../gcc.dg/analyzer/boxed-malloc-1.c          |    8 +-
 .../gcc.dg/analyzer/call-summaries-2.c        |    2 +-
 .../gcc.dg/analyzer/combined-conditionals-1.c |    2 +-
 .../gcc.dg/analyzer/compound-assignment-2.c   |    1 +
 .../gcc.dg/analyzer/compound-assignment-3.c   |    1 +
 .../gcc.dg/analyzer/conditionals-3.c          |    2 +-
 gcc/testsuite/gcc.dg/analyzer/data-model-1.c  |    4 +-
 gcc/testsuite/gcc.dg/analyzer/data-model-15.c |    2 +-
 gcc/testsuite/gcc.dg/analyzer/data-model-17.c |    2 +-
 .../gcc.dg/analyzer/data-model-20a.c          |    2 +-
 gcc/testsuite/gcc.dg/analyzer/data-model-7.c  |    2 +-
 .../analyzer/doom-d_main-IdentifyVersion.c    |   42 +-
 .../gcc.dg/analyzer/doom-s_sound-pr108867.c   |    2 +-
 gcc/testsuite/gcc.dg/analyzer/edges-1.c       |    5 +-
 gcc/testsuite/gcc.dg/analyzer/error-1.c       |    8 +-
 gcc/testsuite/gcc.dg/analyzer/explode-1.c     |    6 +-
 gcc/testsuite/gcc.dg/analyzer/explode-2.c     |    2 +-
 gcc/testsuite/gcc.dg/analyzer/explode-3.c     |    6 +-
 .../gcc.dg/analyzer/fd-datagram-socket.c      |    9 +-
 .../fd-glibc-byte-stream-connection-server.c  |    2 +-
 .../gcc.dg/analyzer/fd-stream-socket.c        |    9 +-
 gcc/testsuite/gcc.dg/analyzer/malloc-1.c      |    6 +-
 .../gcc.dg/analyzer/malloc-many-paths-2.c     |   11 +-
 .../gcc.dg/analyzer/malloc-paths-10.c         |    2 +-
 .../gcc.dg/analyzer/malloc-vs-local-4.c       |    2 +-
 .../gcc.dg/analyzer/memset-CVE-2017-18549-1.c |    4 +-
 .../gcc.dg/analyzer/null-deref-pr102671-1.c   |    2 +-
 .../gcc.dg/analyzer/null-deref-pr102671-2.c   |    2 +-
 gcc/testsuite/gcc.dg/analyzer/pr101143.c      |    2 +-
 gcc/testsuite/gcc.dg/analyzer/pr101837.c      |    4 +-
 .../gcc.dg/analyzer/pr101983-not-main.c       |    2 +-
 gcc/testsuite/gcc.dg/analyzer/pr103892.c      |    2 +-
 gcc/testsuite/gcc.dg/analyzer/pr104224.c      |   17 +-
 .../gcc.dg/analyzer/pr104434-nonconst.c       |    4 +-
 .../analyzer/pr93032-mztools-signed-char.c    |    2 +-
 .../analyzer/pr93032-mztools-unsigned-char.c  |    2 +-
 .../pr93355-localealias-feasibility-2.c       |    2 +-
 .../gcc.dg/analyzer/pr93355-localealias.c     |    6 +-
 gcc/testsuite/gcc.dg/analyzer/pr94579.c       |    2 +-
 gcc/testsuite/gcc.dg/analyzer/pr98599-a.c     |    4 +-
 gcc/testsuite/gcc.dg/analyzer/pr99771-1.c     |   32 +-
 gcc/testsuite/gcc.dg/analyzer/pr99774-2.c     |    8 +-
 gcc/testsuite/gcc.dg/analyzer/sensitive-1.c   |   12 +-
 .../gcc.dg/analyzer/state-diagram-1-sarif.py  |    2 +-
 gcc/testsuite/gcc.dg/analyzer/stdarg-1.c      |    2 +-
 gcc/testsuite/gcc.dg/analyzer/strcmp-1.c      |    8 +-
 gcc/testsuite/gcc.dg/analyzer/strcpy-1.c      |    2 +-
 .../gcc.dg/analyzer/switch-enum-taint-1.c     |    2 +-
 gcc/testsuite/gcc.dg/analyzer/switch.c        |    4 +-
 gcc/testsuite/gcc.dg/analyzer/taint-assert.c  |    2 +-
 .../gcc.dg/analyzer/taint-write-offset-1.c    |    2 +-
 .../analyzer/torture/analyzer-torture.exp     |    2 +-
 .../gcc.dg/analyzer/torture/boxed-ptr-1.c     |    2 +-
 .../torture/fold-ptr-arith-pr105784.c         |    2 +-
 .../gcc.dg/analyzer/torture/loop-inc-ptr-1.c  |    2 +-
 .../gcc.dg/analyzer/torture/pr102225.c        |    3 +-
 .../gcc.dg/analyzer/torture/pr93379.c         |    2 +
 .../gcc.dg/analyzer/torture/stdarg-4.c        |    1 +
 gcc/testsuite/gcc.dg/analyzer/untracked-1.c   |    2 +-
 .../gcc.dg/analyzer/use-after-free.c          |    2 +-
 gcc/testsuite/gcc.dg/analyzer/zlib-3.c        |    6 +-
 .../gcc.dg/plugin/analyzer_cpython_plugin.cc  |   96 +-
 .../gcc.dg/plugin/analyzer_gil_plugin.cc      |   25 +-
 .../gcc.dg/plugin/infoleak-CVE-2011-1078-1.c  |    4 +
 .../gcc.dg/plugin/infoleak-CVE-2011-1078-2.c  |    4 +-
 .../gcc.dg/plugin/infoleak-CVE-2017-18549-1.c |    8 +-
 gcc/testsuite/gdc.dg/analyzer/analyzer.exp    |    2 +-
 .../gfortran.dg/analyzer/analyzer.exp         |    2 +-
 .../gfortran.dg/analyzer/uninit-pr63311.f90   |    1 +
 178 files changed, 8515 insertions(+), 8515 deletions(-)
 create mode 100644 gcc/analyzer/impl-sm-context.h
 create mode 100644 gcc/analyzer/ops.cc
 create mode 100644 gcc/analyzer/ops.h
 create mode 100644 gcc/analyzer/supergraph-fixup-locations.cc
 create mode 100644 gcc/analyzer/supergraph-manipulation.h
 create mode 100644 gcc/analyzer/supergraph-simplify.cc
 create mode 100644 gcc/analyzer/supergraph-sorting.cc
 create mode 100644 gcc/testsuite/c-c++-common/analyzer/coreutils-group_number.c

diff --git a/gcc/analyzer/analyzer-logging.h b/gcc/analyzer/analyzer-logging.h
index e85d293101d..cef33a78ae0 100644
--- a/gcc/analyzer/analyzer-logging.h
+++ b/gcc/analyzer/analyzer-logging.h
@@ -139,6 +139,47 @@ log_scope::~log_scope ()
     }
 }
 
+class log_nesting_level
+{
+public:
+  log_nesting_level (logger *logger, const char *fmt, ...)
+    ATTRIBUTE_GCC_DIAG(3, 4);
+  ~log_nesting_level ();
+
+private:
+  logger *m_logger;
+};
+
+inline
+log_nesting_level::log_nesting_level (logger *logger, const char *fmt, ...)
+: m_logger (logger)
+{
+  if (logger)
+    {
+      va_list ap;
+      va_start (ap, fmt);
+
+      logger->start_log_line ();
+      logger->log_va_partial (fmt, &ap);
+      logger->end_log_line ();
+
+      logger->inc_indent ();
+
+      va_end (ap);
+    }
+}
+
+
+/* The destructor for log_nesting_level; essentially the opposite of
+   the constructor.  */
+
+inline
+log_nesting_level::~log_nesting_level ()
+{
+  if (m_logger)
+    m_logger->dec_indent ();
+}
+
 /* A log_user is something that potentially uses a logger (which could be
    nullptr).
 
diff --git a/gcc/analyzer/analyzer.cc b/gcc/analyzer/analyzer.cc
index 9f6f7b44224..1cfd6e4c58b 100644
--- a/gcc/analyzer/analyzer.cc
+++ b/gcc/analyzer/analyzer.cc
@@ -469,6 +469,16 @@ is_cxa_rethrow_p (const gcall &call)
   return is_named_call_p (fndecl, "__cxa_rethrow");
 }
 
+bool
+is_cxa_end_catch_p (const gcall &call)
+{
+  tree fndecl = gimple_call_fndecl (&call);
+  if (!fndecl)
+    return false;
+
+  return is_named_call_p (fndecl, "__cxa_end_catch");
+}
+
 /* For a CALL that matched is_special_named_call_p or is_named_call_p for
    some name, return a name for the called function suitable for use in
    diagnostics (stripping the leading underscores).  */
diff --git a/gcc/analyzer/analyzer.opt b/gcc/analyzer/analyzer.opt
index 611b987daec..49d230e32ce 100644
--- a/gcc/analyzer/analyzer.opt
+++ b/gcc/analyzer/analyzer.opt
@@ -287,8 +287,8 @@ Common Var(flag_analyzer_debug_text_art) Init(0)
 Add extra annotations to diagrams.
 
 fanalyzer-fine-grained
-Common Var(flag_analyzer_fine_grained) Init(0)
-Avoid combining multiple statements into one exploded edge.
+Common Ignore
+Does nothing. Preserved for backward compatibility.
 
 fanalyzer-feasibility
 Common Var(flag_analyzer_feasibility) Init(1)
@@ -298,6 +298,10 @@ fanalyzer-show-duplicate-count
 Common Var(flag_analyzer_show_duplicate_count) Init(0)
 Issue a note when diagnostics are deduplicated.
 
+fanalyzer-simplify-supergraph
+Common Var(flag_analyzer_simplify_supergraph) Init(1)
+Simplify the supergraph before analyzing it.
+
 fanalyzer-state-purge
 Common Var(flag_analyzer_state_purge) Init(1)
 Purge unneeded state during analysis.
diff --git a/gcc/analyzer/bounds-checking.cc b/gcc/analyzer/bounds-checking.cc
index 7c51ca27bc5..04aaee3cdc0 100644
--- a/gcc/analyzer/bounds-checking.cc
+++ b/gcc/analyzer/bounds-checking.cc
@@ -1327,7 +1327,7 @@ strip_types (const svalue *sval,
 	const widening_svalue *widening_sval = (const widening_svalue *)sval;
 	return mgr.get_or_create_widening_svalue
 	  (NULL_TREE,
-	   widening_sval->get_point (),
+	   widening_sval->get_snode (),
 	   strip_types (widening_sval->get_base_svalue (), mgr),
 	   strip_types (widening_sval->get_iter_svalue (), mgr));
       }
diff --git a/gcc/analyzer/call-details.h b/gcc/analyzer/call-details.h
index c0a9118e658..272be2399fd 100644
--- a/gcc/analyzer/call-details.h
+++ b/gcc/analyzer/call-details.h
@@ -21,6 +21,8 @@ along with GCC; see the file COPYING3.  If not see
 #ifndef GCC_ANALYZER_CALL_DETAILS_H
 #define GCC_ANALYZER_CALL_DETAILS_H
 
+#include "pending-diagnostic.h"
+
 namespace ana {
 
 /* Helper class for handling calls to functions with known behavior.  */
diff --git a/gcc/analyzer/call-info.cc b/gcc/analyzer/call-info.cc
index f43114344cf..1470b95c1bd 100644
--- a/gcc/analyzer/call-info.cc
+++ b/gcc/analyzer/call-info.cc
@@ -58,6 +58,14 @@ custom_edge_info::update_state (program_state *state,
   return update_model (state->m_region_model, eedge, ctxt);
 }
 
+void
+custom_edge_info::get_dot_attrs (const char *&out_style,
+				 const char *&out_color) const
+{
+  out_color = "red";
+  out_style = "\"dotted\"";
+}
+
 /* Base implementation of custom_edge_info::create_enode vfunc.  */
 
 exploded_node *
@@ -87,7 +95,8 @@ call_info::print (pretty_printer *pp) const
 
 void
 call_info::add_events_to_path (checker_path *emission_path,
-			       const exploded_edge &eedge) const
+			       const exploded_edge &eedge,
+			       pending_diagnostic &) const
 {
   class call_event : public custom_event
   {
@@ -114,9 +123,9 @@ call_info::add_events_to_path (checker_path *emission_path,
 
   emission_path->add_event
     (std::make_unique<call_event> (event_loc_info (get_call_stmt ().location,
-					      caller_fndecl,
-					      stack_depth),
-			      this));
+						   caller_fndecl,
+						   stack_depth),
+				   this));
 }
 
 /* Recreate a call_details instance from this call_info.  */
diff --git a/gcc/analyzer/call-info.h b/gcc/analyzer/call-info.h
index 6548d861bf2..63fd008cb62 100644
--- a/gcc/analyzer/call-info.h
+++ b/gcc/analyzer/call-info.h
@@ -32,7 +32,8 @@ class call_info : public custom_edge_info
 public:
   void print (pretty_printer *pp) const override;
   void add_events_to_path (checker_path *emission_path,
-			   const exploded_edge &eedge) const override;
+			   const exploded_edge &eedge,
+			   pending_diagnostic &pd) const override;
 
   const gcall &get_call_stmt () const { return m_call_stmt; }
   tree get_fndecl () const { return m_fndecl; }
diff --git a/gcc/analyzer/call-string.cc b/gcc/analyzer/call-string.cc
index 0bac8b43734..a016f9d89a7 100644
--- a/gcc/analyzer/call-string.cc
+++ b/gcc/analyzer/call-string.cc
@@ -39,7 +39,7 @@ along with GCC; see the file COPYING3.  If not see
 bool
 call_string::element_t::operator== (const call_string::element_t &other) const
 {
-  return (m_caller == other.m_caller && m_callee == other.m_callee);
+  return m_call_sedge == other.m_call_sedge;
 }
 
 /* call_string::element_t's inequality operator.  */
@@ -52,13 +52,25 @@ call_string::element_t::operator!= (const call_string::element_t &other) const
 function *
 call_string::element_t::get_caller_function () const
 {
-  return m_caller->get_function ();
+  return m_call_sedge->m_src->get_function ();
 }
 
-function *
-call_string::element_t::get_callee_function () const
+const supernode *
+call_string::element_t::get_call_snode_in_caller () const
+{
+  return m_call_sedge->m_src;
+}
+
+const supernode *
+call_string::element_t::get_return_snode_in_caller () const
+{
+  return m_call_sedge->m_dest;
+}
+
+const gcall &
+call_string::element_t::get_call_stmt () const
 {
-  return m_callee->get_function ();
+  return m_call_op->get_gcall ();
 }
 
 /* Print this to PP.  */
@@ -75,17 +87,18 @@ call_string::print (pretty_printer *pp) const
       if (i > 0)
 	pp_string (pp, ", ");
       pp_printf (pp, "(SN: %i -> SN: %i in %s)",
-		 e->m_callee->m_index, e->m_caller->m_index,
-		 function_name (e->m_caller->m_fun));
+		 e->get_call_snode_in_caller ()->m_id,
+		 e->get_return_snode_in_caller ()->m_id,
+		 function_name (e->get_caller_function ()));
     }
 
   pp_string (pp, "]");
 }
 
 /* Return a new json::array of the form
-   [{"src_snode_idx" : int,
-     "dst_snode_idx" : int,
-     "funcname" : str},
+   [{"call_sedge_src" : int,
+     "call_sedge_dest" : int,
+     "called_fun" : str},
      ...for each element in the callstring].  */
 
 std::unique_ptr<json::value>
@@ -96,36 +109,25 @@ call_string::to_json () const
   for (const call_string::element_t &e : m_elements)
     {
       auto e_obj = std::make_unique<json::object> ();
-      e_obj->set_integer ("src_snode_idx", e.m_callee->m_index);
-      e_obj->set_integer ("dst_snode_idx", e.m_caller->m_index);
-      e_obj->set_string ("funcname", function_name (e.m_caller->m_fun));
+      e_obj->set_integer ("call_sedge_src", e.m_call_sedge->m_src->m_id);
+      e_obj->set_integer ("call_sedge_dest", e.m_call_sedge->m_dest->m_id);
+      e_obj->set_string ("called_fun", function_name (e.m_called_fun));
       arr->append (std::move (e_obj));
     }
 
   return arr;
 }
 
-/* Get or create the call_string resulting from pushing the return
-   superedge for CALL_SEDGE onto the end of this call_string.  */
-
-const call_string *
-call_string::push_call (const supergraph &sg,
-			const call_superedge *call_sedge) const
-{
-  gcc_assert (call_sedge);
-  const return_superedge *return_sedge = call_sedge->get_edge_for_return (sg);
-  gcc_assert (return_sedge);
-  return push_call (return_sedge->m_dest, return_sedge->m_src);
-}
 
 /* Get or create the call_string resulting from pushing the call
    (caller, callee) onto the end of this call_string.  */
 
 const call_string *
-call_string::push_call (const supernode *caller,
-			const supernode *callee) const
+call_string::push_call (const superedge &call_sedge,
+			const call_and_return_op &call_op,
+			function &called_fun) const
 {
-  call_string::element_t e (caller, callee);
+  call_string::element_t e (&call_sedge, &call_op, &called_fun);
 
   if (const call_string **slot = m_children.get (e))
     return *slot;
@@ -160,10 +162,10 @@ call_string::count_occurrences_of_function (function *fun) const
   int result = 0;
   for (const call_string::element_t &e : m_elements)
     {
-      if (e.get_callee_function () == fun)
-	result++;
       if (e.get_caller_function () == fun)
 	result++;
+      if (e.get_callee_function () == fun)
+	result++;
     }
   return result;
 }
@@ -199,14 +201,10 @@ call_string::cmp (const call_string &a,
       /* Otherwise, compare the node pairs.  */
       const call_string::element_t a_node_pair = a[i];
       const call_string::element_t b_node_pair = b[i];
-      int src_cmp
-	= a_node_pair.m_callee->m_index - b_node_pair.m_callee->m_index;
+      int src_cmp = (a_node_pair.m_call_sedge->m_src->m_id
+		     - b_node_pair.m_call_sedge->m_src->m_id);
       if (src_cmp)
 	return src_cmp;
-      int dest_cmp
-	= a_node_pair.m_caller->m_index - b_node_pair.m_caller->m_index;
-      if (dest_cmp)
-	return dest_cmp;
       i++;
       // TODO: test coverage for this
     }
@@ -222,24 +220,14 @@ call_string::cmp_ptr_ptr (const void *pa, const void *pb)
   return cmp (*cs_a, *cs_b);
 }
 
-/* Return the pointer to callee of the topmost call in the stack,
-   or nullptr if stack is empty.  */
-const supernode *
-call_string::get_callee_node () const
-{
-  if(m_elements.is_empty ())
-    return nullptr;
-  return m_elements[m_elements.length () - 1].m_callee;
-}
-
 /* Return the pointer to caller of the topmost call in the stack,
    or nullptr if stack is empty.  */
 const supernode *
-call_string::get_caller_node () const
+call_string::get_return_node_in_caller () const
 {
   if(m_elements.is_empty ())
     return nullptr;
-  return m_elements[m_elements.length () - 1].m_caller;
+  return m_elements[m_elements.length () - 1].get_return_snode_in_caller ();
 }
 
 /* Assert that this object is sane.  */
@@ -258,9 +246,14 @@ call_string::validate () const
   call_string::element_t *e;
   int i;
   FOR_EACH_VEC_ELT (m_elements, i, e)
+    {
+      gcc_assert (e->m_call_op == e->m_call_sedge->get_op ());
+#if 0
     if (i > 0)
       gcc_assert (e->get_caller_function () ==
 		  m_elements[i - 1].get_callee_function ());
+#endif
+    }
 }
 
 /* ctor for the root/empty call_string.  */
@@ -308,8 +301,9 @@ call_string::recursive_log (logger *logger) const
       /* Log the final element in detail.  */
       const element_t *e = &m_elements[m_elements.length () - 1];
       pp_printf (pp, "(SN: %i -> SN: %i in %s)]",
-		 e->m_callee->m_index, e->m_caller->m_index,
-		 function_name (e->m_caller->m_fun));
+		 e->m_call_sedge->m_src->m_id,
+		 e->m_call_sedge->m_dest->m_id,
+		 function_name (e->get_caller_function ()));
     }
   else
     pp_string (pp, "[]");
diff --git a/gcc/analyzer/call-string.h b/gcc/analyzer/call-string.h
index f8c6a257cf5..e113a3a2819 100644
--- a/gcc/analyzer/call-string.h
+++ b/gcc/analyzer/call-string.h
@@ -25,20 +25,13 @@ namespace ana {
 
 class supergraph;
 class supernode;
-class call_superedge;
-class return_superedge;
+  class call_and_return_op;
 
-
-/* A string of return_superedge pointers, representing a call stack
-   at a program point.
+/* A string of "elements" representing a call stack at a program point.
 
    This is used to ensure that we generate interprocedurally valid paths
    i.e. that we return to the same callsite that called us.
 
-   The class stores returning calls ( which may be represented by a
-   returning superedge ). We do so because this is what we need to compare
-   against.
-
    Instances of call_string are consolidated by the region_model_manager,
    which effectively owns them: it owns the root/empty call_string, and each
    call_string instance tracks its children, lazily creating them on demand,
@@ -49,13 +42,19 @@ class call_string
 public:
   /* A struct representing an element in the call_string.
 
-   Each element represents a path from m_callee to m_caller which represents
-   returning from function.  */
+     Each element represents a "call superedge" within the caller for which
+     the op was a call_and_return_op.
+     Returning from the callee to the caller will involve creating a custom
+     exploded edge from the exit supernode in the callee to the destination
+     of the call superedge within the caller.  */
 
   struct element_t
   {
-    element_t (const supernode *caller, const supernode *callee)
-    :  m_caller (caller), m_callee (callee)
+    element_t (const superedge *call_sedge,
+	       const call_and_return_op *call_op,
+	       function *called_fun)
+    :  m_call_sedge (call_sedge), m_call_op (call_op),
+       m_called_fun (called_fun)
     {
     }
 
@@ -64,10 +63,14 @@ public:
 
     /* Accessors */
     function *get_caller_function () const;
-    function *get_callee_function () const;
-
-    const supernode *m_caller;
-    const supernode *m_callee;
+    function *get_callee_function () const { return m_called_fun; }
+    const supernode *get_call_snode_in_caller () const;
+    const supernode *get_return_snode_in_caller () const;
+    const gcall &get_call_stmt () const;
+
+    const superedge *m_call_sedge;
+    const call_and_return_op *m_call_op;
+    function *m_called_fun;
   };
 
   void print (pretty_printer *pp) const;
@@ -76,11 +79,9 @@ public:
 
   bool empty_p () const { return m_elements.is_empty (); }
 
-  const call_string *push_call (const supergraph &sg,
-				const call_superedge *sedge) const;
-
-  const call_string *push_call (const supernode *src,
-				const supernode *dest) const;
+  const call_string *push_call (const superedge &call_sedge,
+				const call_and_return_op &call_op,
+				function &called_fun) const;
   const call_string *get_parent () const { return m_parent; }
 
   int calc_recursion_depth () const;
@@ -91,9 +92,7 @@ public:
   static int cmp_ptr_ptr (const void *, const void *);
 
   /* Accessors */
-
-  const supernode *get_callee_node () const;
-  const supernode *get_caller_node () const;
+  const supernode *get_return_node_in_caller () const;
   unsigned length () const { return m_elements.length (); }
   element_t operator[] (unsigned idx) const
   {
@@ -119,8 +118,8 @@ private:
     static inline hashval_t hash (const key_type &k)
     {
       inchash::hash hstate;
-      hstate.add_ptr (k.m_caller);
-      hstate.add_ptr (k.m_callee);
+      hstate.add_ptr (k.m_call_sedge);
+      //hstate.add_ptr (&k.m_call_op);
       return hstate.end ();
     }
     static inline bool equal_keys (const key_type &k1, const key_type &k2)
@@ -129,25 +128,25 @@ private:
     }
     template <typename T> static inline void remove (T &entry)
     {
-      entry.m_key = element_t (nullptr, nullptr);
+      entry.m_key = element_t (nullptr, nullptr, nullptr);
     }
     static const bool empty_zero_p = true;
     template <typename T> static inline bool is_empty (const T &entry)
     {
-      return entry.m_key.m_caller == nullptr;
+      return entry.m_key.m_call_sedge == nullptr;
     }
     template <typename T> static inline bool is_deleted (const T &entry)
     {
-      return entry.m_key.m_caller == reinterpret_cast<const supernode *> (1);
+      return entry.m_key.m_call_sedge == reinterpret_cast<const superedge *> (1);
     }
     template <typename T> static inline void mark_empty (T &entry)
     {
-      entry.m_key = element_t (nullptr, nullptr);
+      entry.m_key = element_t (nullptr, nullptr, nullptr);
       entry.m_value = nullptr;
     }
     template <typename T> static inline void mark_deleted (T &entry)
     {
-      entry.m_key.m_caller = reinterpret_cast<const supernode *> (1);
+       entry.m_key.m_call_sedge = reinterpret_cast<const superedge *> (1);
     }
   };
 
diff --git a/gcc/analyzer/call-summary.cc b/gcc/analyzer/call-summary.cc
index 14ff560b23a..7a3d4aac7c6 100644
--- a/gcc/analyzer/call-summary.cc
+++ b/gcc/analyzer/call-summary.cc
@@ -38,7 +38,7 @@ call_summary::get_state () const
 tree
 call_summary::get_fndecl () const
 {
-  return m_enode->get_point ().get_fndecl ();
+  return m_enode->get_function ()->decl;
 }
 
 label_text
@@ -393,7 +393,7 @@ call_summary_replay::convert_svalue_from_summary_1 (const svalue *summary_sval)
       {
 	const widening_svalue *widening_summary_sval
 	  = as_a <const widening_svalue *> (summary_sval);
-	const function_point &point = widening_summary_sval->get_point ();
+	const supernode *snode = widening_summary_sval->get_snode ();
 	const svalue *summary_base_sval
 	  = widening_summary_sval->get_base_svalue ();
 	const svalue *caller_base_sval
@@ -411,7 +411,7 @@ call_summary_replay::convert_svalue_from_summary_1 (const svalue *summary_sval)
 	region_model_manager *mgr = get_manager ();
 	return mgr->get_or_create_widening_svalue
 	  (summary_iter_sval->get_type (),
-	   point,
+	   snode,
 	   caller_base_sval,
 	   caller_iter_sval);
       }
